const Encore = require('@symfony/webpack-encore');

// Manually configure the runtime environment if not already configured yet by the "encore" command.
// It's useful when you use tools that rely on webpack.config.js file.


// https://symfony.com/doc/current/frontend/encore/dev-server.html#enabling-https-using-the-symfony-web-server
const path = require('path');

let app_env = (process.env.NODE_ENV || 'dev');

// console.log("Encore.isProduction() = ", Encore.isProduction());

if (!Encore.isRuntimeEnvironmentConfigured()) {
    Encore.configureRuntimeEnvironment(app_env);
}
if (Encore.isProduction()) {
    app_env = 'prod';
}

console.log("app_env = ", app_env);
console.log("process.env.HOME = ", process.env.HOME);

Encore
    // directory where compiled assets will be stored
    .setOutputPath('public/build/')
    // public path used by the web server to access the output path
    .setPublicPath('/build')
    // only needed for CDN's or subdirectory deploy
    //.setManifestKeyPrefix('build/')

    /*
     * ENTRY CONFIG
     *
     * Each entry will result in one JavaScript file (e.g. app.js)
     * and one CSS file (e.g. app.css) if your JavaScript imports CSS.
     */
    .addEntry('app-www',   './assets/app.ts')
    .addEntry('app-admin', './assets/app-admin.ts')
    .addEntry('app-auth',  './assets/app-auth.ts')
    // .addEntry('admin-react',  './assets/react/index.tsx')

    // When enabled, Webpack "splits" your files into smaller pieces for greater optimization.
    .splitEntryChunks()

    // enables the Symfony UX Stimulus bridge (used in assets/bootstrap.js)
    .enableStimulusBridge('./assets/controllers.json')

    // will require an extra script tag for runtime.js
    // but, you probably want this, unless you're building a single-page app
    .enableSingleRuntimeChunk()

    .copyFiles(
        { from: './assets/img', to: 'img/[path][name].[ext]' }
    )
    .copyFiles(
        { from: `./assets/favicon/${app_env}`, to: 'favicon/[path][name].[ext]' }
    )
    .copyFiles(
        { from: `./assets/vendor`, to: 'vendor/[path][name].[ext]' }
    )

    /*
     * FEATURE CONFIG
     *
     * Enable & configure other features below. For a full
     * list of features, see:
     * https://symfony.com/doc/current/frontend.html#adding-more-features
     */
    .cleanupOutputBeforeBuild()
    .enableBuildNotifications()
    .enableSourceMaps(!Encore.isProduction())
    // enables hashed filenames (e.g. app.abc123.css)
    .enableVersioning(Encore.isProduction())

    // configure Babel
    // .configureBabel((config) => {
    //     config.plugins.push('@babel/a-babel-plugin');
    // })

    // enables and configure @babel/preset-env polyfills
    .configureBabelPresetEnv((config) => {
        config.useBuiltIns = 'usage';
        config.corejs = '3.23';
    })

    // enables Sass/SCSS support
    .enableSassLoader((options) => {
        options.additionalData = `$app_env:${app_env};`
    })

    // uncomment if you use TypeScript
    .enableTypeScriptLoader()

    // uncomment if you use React
    .enableReactPreset()

    // uncomment to get integrity="..." attributes on your script & link tags
    // requires WebpackEncoreBundle 1.4 or higher
    //.enableIntegrityHashes(Encore.isProduction())

    // uncomment if you're having problems with a jQuery plugin
    .autoProvidejQuery()

    // https://symfony.com/doc/current/frontend/encore/dev-server.html#enabling-https-using-the-symfony-web-server
    // .configureDevServerOptions(options => {
    //     options.server = {
    //         type: 'https',
    //         options: {
    //             pfx: path.join(process.env.HOME, '.symfony5/certs/default.p12'),
    //             // cert: 'C:\\Users\\prince\\.symfony5\\certs\\rootCA.pem',
    //             // key: 'C:\\Users\\prince\\.symfony5\\certs\\rootCA-key.pem'
    //         }
    //     }
    // })
    .isDev(() => { return true })
;

module.exports = Encore.getWebpackConfig();
